<template>
  <div class="deposit-page">
    <div class="wrapper-content">
      <div class="left-content">
        <div class="title-page">
          {{ $t('deposit.header') }}
        </div>

        <div class="selected-coin-msg"><p class="title">{{ $t('deposit.title') }}</p></div>

        <div class="list-coin">
          <div class="coin-item" v-for="(coin, index) in listCoin" @click="selectCoin(index)" :class="{ 'active': isCurrentCoin(coin) }">
            <div class="coin-infor">
              <img :src="coin.srcImg" :alt="coin.fullname" class="coin__image">
                <span class="coin__name">{{ coin.name }}</span>
            </div>
          </div>
        </div>

        <template v-if="currentWallet">
          <div class="balance">
            <p class="balance__text">{{ $t('deposit.balance') }}</p>
            <p class="balance__value">{{ currentWallet.balance | formatCurrencyAmount(currentWallet.currency, '0') }} {{ currentWallet.currency.toUpperCase() }}</p>
          </div>

          <div class="content-box">
            <div class="address-wrapper">
              <p class="title">
                {{ $t('deposit.address', {currency: currentWallet.currency.toUpperCase()}) }}
              </p>
              <p class="address">
                {{ currentWallet.address }}
              </p>
            </div>
            <div class="group-btn">
              <div class="group-item">
                <p class="show-qr-btn" @click="showQrModal">
                  <span class="iconmo-QRcode"></span>
                  <span class="btn__text">{{ $t('deposit.btn.show_qr') }}</span>
                </p>
              </div>  

              <div class="group-item" v-clipboard:copy="currentWallet.address" @click="isShowTooltip = !isShowTooltip"
               v-tooltip="{content: 'Copied', trigger: 'click',boundariesElement: 'window',show: isShowTooltip , classes: ['hide', 'hideAnim']}">
                <p class="copy-btn">
                  <span class="iconmo-copy"></span>
                  <span class="btn__text">{{ $t('deposit.btn.copy') }}</span>
                </p>
              </div>
            </div>
          </div>

          <div class="text-box">
            <div class="important">
              <p class="title">
                {{$t('deposit.important.title')}}
              </p>

              <p class="description">
                {{ $t('deposit.important.description', {currency: currentWallet.currency.toUpperCase()}) }}
              </p>
            </div>

            <div class="note">
              <p class="title">
                {{ $t('deposit.note.title') }}
              </p>

              <ul class="note__list">
                <li class="item">
                  {{ $t('deposit.note.description1', {confirmation: $options.filters.expectedConfirmation(currentCoin)}) }}
                </li>
                <li class="item">
                  {{ $t('deposit.note.description2') }}
                  <router-link to='/wallet/transactions'><span class='link'>{{$t('deposit.note.history_page')}}</span></router-link>
                </li>
                <li class="item">
                  {{
                    $t('deposit.note.description3', {
                      amount: $options.filters.minDeposit(currentCoin),
                      currency: $options.filters.uppercase(currentCoin),
                    })
                  }}
                </li>
              </ul>
            </div>
          </div>
        </template>
      </div>
    </div>
  </div>
</template>
<script>
  import { mapState, mapActions } from 'vuex';
  import QrModal from '../components/Modal/QrModal';

  export default {
    name: 'Deposit',
    components: {
      QrModal,
    },
    data() {
      return {
        currentCoin: '',
        isShowTooltip: false,
        listCoin: [
          {
            srcImg: "/images/icon/balanceImg/heta-btc-icon.png",
            name: "btc",
            fullname: "Bitcoin",
          },
          {
            srcImg: "/images/icon/balanceImg/heta-usdt-icon.png",
            name: "usdt",
            fullname: "TetherUS",
          },
          {
            srcImg: "/images/icon/balanceImg/heta-eth-icon.png",
            name: "eth",
            fullname: "Ethereum",
          },
        ],
        modalData: {},
      }
    },
    computed: {
      ...mapState(['wallets']),
      currentWallet() {
        if (!this.wallets || !this.currentCoin) {
          return;
        }
        return this.wallets.find(wallet => wallet.currency === this.currentCoin);
      },
    },
    methods: {
      selectCoin(index) {
        this.currentCoin = this.listCoin[index].name;
        this.fetchDepositAddress(this.currentCoin);
        if (this.$route.query.currency !== this.currentCoin) {
          this.$router.push({ query: { currency: this.currentCoin } });
        }
      },
      isCurrentCoin(coin) {
        return coin.name === this.currentCoin;
      },
      showQrModal() {
        if (!this.currentWallet) {
          return;
        }
        this.modalData = {
          title: this.currentWallet.currency,
          address: this.currentWallet.address,
          
        }
        this.$broadcast('open-modal', QrModal, this.modalData);
      },
      ...mapActions(['fetchDepositAddress']),
    },
    mounted() {
      const currency = this.$route.query.currency;
      const foundIndex = this.listCoin.findIndex(coin => coin.name === currency);
      if (foundIndex !== -1) {
        this.selectCoin(foundIndex);
      }
    },
  }
</script>

<style scoped lang="scss">
  @import '../../../sass/mobile/typoVariables.scss';
  * {
    font-family: $font-family-home;
  }

  .wrapper-content {
    position: relative;

    &:after {
      background-color: #fff;
    }
  }

  .deposit-page {
    font-size: 0;
    background: $bg_primary;
  }

  .title-page {
    font-size: 18rem;
    color: $white;
    margin-bottom: 35rem;
    padding: 13rem 12rem 13rem;
    background-image: linear-gradient(to bottom, $midnight, $catalina_blue);
    box-shadow: 0 2rem 40rem 0 rgba(0, 0, 0, 0.5);
  }
  
  .title-page,
  .balance,
  .content-box {
    padding-left: 12rem;
    padding-right: 12rem;
  }

  .left-content {
    min-height: 327rem;
  }
  
  .list-coin {
    padding: 0 6rem;
    font-size: 0;
    margin: 0 0 19rem;

    .coin-item {
      position: relative;
      cursor: pointer;
      display: inline-block;
      padding: 0 6rem;
      width: 33.33%;

      .coin-infor {
        background-color: #e0e0e0;
        border-radius: 40rem;
        padding: 3rem 10rem;
        .coin__image {
          width: 25rem;
          margin-right: 5rem;
          vertical-align: middle;
        }

        .coin__name {
          vertical-align: middle;
          font-size: $small;
          font-weight: bold;
          text-transform: uppercase;
          color: $black;
          margin-right: 3rem;
        }
      }

      &.active .coin-infor {
        .coin__name {
          color: #fff;
        }
        background-color: $dark_orange;
      }
    }
  }

  .down-arrow {
    font-family: FontAwesome;
  }

  .balance {
    margin-bottom: 5rem;

    .balance__text {
      font-size: $small;
      color: #989898;
      margin-bottom: -2rem;
    }

    .balance__value {
      font-size: $small;
      font-weight: bold;
      color: $gray;
    }
  }

  .content-box {
    margin-bottom: 30rem;
    .title {
      font-size: $small;
      color: #989898;
      margin-bottom: 0;
    }

    .address-wrapper {
      border-bottom: 1rem solid #e0e0e0;
      margin-bottom: 19rem;
      padding-bottom: 16rem;
    }

    .address {
      font-weight: bold;
      font-size: $small;
      color: $black;
      word-break: break-all;
    }
    @media screen and (max-width: 320rem) {
      .address {
        font-size: 13rem;
      }
    }
  }

  .selected-coin-msg {
    padding-left: 12rem;
    padding-right: 12rem;
    margin-bottom: 15rem;
    margin-top: -15rem;
    .title {
      font-size: $small;
      color: #989898;
      margin-bottom: 0;
    }
  }

  .group-btn {
    margin: 0 -2.5rem;

    .group-item {
      display: inline-block;
      width: 50%;
      padding: 0 2.5rem;
    }
  }

  .show-qr-btn,
  .copy-btn {
    cursor: pointer;
    border-radius: 30rem;
    border: solid 1rem #da6400;
    transition: all 0.3s ease-in-out;
    text-align: center;
    box-sizing: content-box;

    .iconmo-copy,
    .iconmo-QRcode {
      vertical-align: middle;
    }
    
    .btn__text {
      font-size: $tiny;
      margin-left: 5rem;
      vertical-align: middle;
      text-transform: uppercase;
      font-weight: bold;
      line-height: 2.5;
      letter-spacing: 0.5rem;
      color: #fa7300;
    }
  }

  .copy-btn {
    padding: 1rem;
    border: none;
    background-color: #fa7300;

    .btn__text {
      color: #fff;
    }
  }
  
  .iconmo-QRcode {
    font-size: 16rem;
  }

  .iconmo-copy {
    font-size: 16rem;
    &:before {
      color: #fff;
    }
  }

  .text-box {
    background-color: #e8e8e8;
    padding: 15rem 24rem;

    .title {
      font-size: $small;
      font-weight: bold;
      color: #1c1c1c;
      margin-bottom: 0;
    }

    .description {
      font-size: $small;
      color: #505050;
      line-height: 1.29;
    }

    .important {
      margin-bottom: 20rem;
    }
  }

  .note__list {
    padding-left: 0;
    list-style: none;

    .item {
      position: relative;
      font-size: $small;
      line-height: 1.79;
      color: #505050;
      padding-left: 12rem;

      &:before {
        border-radius: 50%;
        content: '';
        display: block;
        width: 3rem;
        height: 3rem;
        background-color: $gray;
        position: absolute;
        top: 50%;
        transform: translateY(-50%);
        left: 0;
      }
    }
  }
</style>
